//+------------------------------------------------------------------+
//|                                                  Nifty Trend.mq4 |
//|                                                 Vignesh Vetrivel |
//|                                          vetri.trading@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Vignesh Vetrivel"
#property link      "vetri.trading@gmail.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
enum location
  {
   TopRight=1,      //Top Right
   BottomLeft=2,    //Bottom Left
   BottomRight=3,   //Bottom Right
   TopLeft=4,       //Top Left
  };
enum timeprice
  {
   time=1,    //Time
   price=2,   //Price
   both=3,    //Time and Price
  };
//---input parameters
input timeprice tp=both;         //Display Time/Price/Both
input string     Price_Settings="Price Settings"; //----------------------------------------------------------------------------
input int        price_fontsize=12;               //Font Size
input bool       bidask_color=TRUE;               //Bid Ask Color
extern color     price_color=clrWhite;               //Color
input location   price_location=BottomRight;        //Location
input int        digitp=4;               //Digit
double           current_price;
input string     Settings="-----------------------------------------------------------------------";   //----------------------------------------------------------------------------
extern string    Time_Settings="Time Settings";   //----------------------------------------------------------------------------
input int        time_fontsize=12;                //Font Size
input color      time_color=clrWhite;                //Color
input location   time_location=BottomRight;       //Location
double           leftTime;
string           sTime,market_price;
int              days;
bool             alert_played=FALSE;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   ObjectCreate(ChartID(),"Market Price",OBJ_LABEL,0,0,0);
   ObjectSet("Market Price",OBJPROP_CORNER,price_location);
   ObjectSet("Market Price",OBJPROP_XDISTANCE,5);
   ObjectSet("Market Price",OBJPROP_YDISTANCE,5);

   ObjectCreate(ChartID(),"Remaining time to candle close",OBJ_LABEL,0,0,0);
   ObjectSet("Remaining time to candle close",OBJPROP_CORNER,time_location);
   ObjectSet("Remaining time to candle close",OBJPROP_XDISTANCE,5);
   ObjectSet("Remaining time to candle close",OBJPROP_YDISTANCE,20);

   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete(ChartID(),"Remaining time to candle close");
   ObjectDelete(ChartID(),"Market Price");
   return(INIT_SUCCEEDED);
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void start()
  {
   switch(tp)
     {
      case 1:
         ObjectDelete(ChartID(),"Market Price");
         leftTime=(Period()*60)-(TimeCurrent()-Time[0]);
         if(leftTime<20)
           {
            PlaySound("alert.wav");
            alert_played=TRUE;
           }
         if(leftTime>80)
            alert_played=FALSE;

         sTime=TimeToStr(leftTime,TIME_SECONDS);
         if(DayOfWeek()==0 || DayOfWeek()==6)
           {
            if(time_location==2)
               Comment("Market is Closed");
            else
               ObjectSetText("Remaining time to candle close","Market is Closed",time_fontsize,"Calibri",time_color);
           }
         else
           {
            if(Period()==PERIOD_MN1 || Period()==PERIOD_W1)
              {
               days=((leftTime/60)/60)/24;
               if(time_location==2)
                  Comment("CCTR: "+IntegerToString(days)+"D - "+sTime);
               else
                  ObjectSetText("Remaining time to candle close",IntegerToString(days)+"D - "+sTime,time_fontsize,"Calibri",time_color);
              }
            else
              {
               if(time_location==2)
                  Comment("Time to Candle Close"+sTime);
               else
                  ObjectSetText("Remaining time to candle close",sTime,time_fontsize,"Calibri",time_color);
              }
           }
         break;
      case 2:
         ObjectDelete(ChartID(),"Remaining time to candle close");
         current_price=Close[0];
         market_price=DoubleToStr(Close[0],digitp);
         ObjectSetText("Market Price",market_price,price_fontsize,"Calibri",price_color);
         break;
      default:
         current_price=Close[0];
         market_price=DoubleToStr(Close[0],digitp);
         ObjectSetText("Market Price",market_price,price_fontsize,"Calibri",price_color);

         leftTime=(Period()*60)-(TimeCurrent()-Time[0]);
         if(leftTime<40)
           {
            PlaySound("alert.wav");
            alert_played=TRUE;
           }
         if(leftTime>80)
            alert_played=FALSE;

         sTime=TimeToStr(leftTime,TIME_SECONDS);
         if(DayOfWeek()==0 || DayOfWeek()==6)
           {
            if(time_location==2)
               Comment("Market is Closed");
            else
               ObjectSetText("Remaining time to candle close","Market is Closed",time_fontsize,"Calibri",time_color);
           }
         else
           {
            if(Period()==PERIOD_MN1 || Period()==PERIOD_W1)
              {
               days=((leftTime/60)/60)/24;
               if(time_location==2)
                  Comment("CCTR: "+IntegerToString(days)+"D - "+sTime);
               else
                  ObjectSetText("Remaining time to candle close",IntegerToString(days)+"D - "+sTime,time_fontsize,"Calibri",time_color);
              }
            else
              {
               if(time_location==2)
                  Comment("Time to Candle Close"+sTime);
               else
                  ObjectSetText("Remaining time to candle close",sTime,time_fontsize,"Calibri",time_color);
              }
           }

         break;
     }
  }
//+------------------------------------------------------------------+
